﻿#target InDesign
function main(){
    if(app.selection.length!=0){
        var bps=app.extractLabel("jp.co.matsuzawa.vertical_cell_merge");
        var sel=app.selection[0],st="";
        if(sel.constructor.name.match(/^(Table|Cell)$/)){
            var st=(sel.constructor.name==="Table")? sel.cells[0].name.split(":"): sel.name.split(":");
            st=[Number(st[0]), Number(st[1])];
            var et=[st[0]+sel.columns.length-1,st[1]+sel.rows.length-1];
            var vvvvv=false;
            var dlg=app.dialogs.add({name:'セルを縦方向に結合'});
            var bP1=dlg.dialogColumns.add().dialogRows.add().borderPanels.add({minWidth:200});
            var dlgRg1=bP1.radiobuttonGroups.add();
            var dlgCc0=dlgRg1.radiobuttonControls.add({staticLabel:"空欄"});
            var dlgCc1=dlgRg1.radiobuttonControls.add({staticLabel:"罫線"});
            switch(bps){
                case "1": dlgCc1.checkedState=true; break;
                default: dlgCc0.checkedState=true; break;
            }
            if(dlg.show()){
                app.insertLabel("jp.co.matsuzawa.vertical_cell_merge",""+dlgRg1.selectedButton+"");
                switch(dlgRg1.selectedButton){
                    case 0: var mode={contents:true,stroke:false}; break;
                    case 1: var mode={contents:false,stroke:true}; break;
                    default: break;
                }
            }else{ exit(); }
            if("rows" in sel.parent){
                sel.parent.rows.add();
            }else{
                sel.rows.add();
            }
            for(var i=et[0];i>=st[0];i--){
                var f=false,memCell=null,trg="",val=undefined,sameCol=null;
                sameCol=i+":"+et[1];
                for(var j=et[1];j>=st[1];j--){
                    trg=app.selection[0].cells.itemByName(i+":"+j);
                    if(!trg.isValid){
                        var allCells=sel.cells.everyItem().getElements();
                        var eFF=false;
                        for(var su=allCells.length-1;su>-1;su--){
                            if(allCells[su].name===i+":"+j){
                                trg=allCells[su];
                                eFF=true;
                            }
                        }
                    }else{
                        if(mode.contents){
                            val=(trg.texts[0].contents==="")? true: false;
                        }else if(mode.stroke){
                            val=(trg.topEdgeStrokeWeight===0)? true: false;
                        }
                    }
                    if(!f && val){
                        f=true;
                        memCell=trg;
                    }else if(f && !val){
                        trg.merge(memCell);
                        vvvvv=true;
                        f=false;
                        memCell=null;
                    }
                }
            }
            if("rows" in app.selection[0].parent){
                app.selection[0].parent.rows.lastItem().remove();
            }else{
                app.selection[0].rows.lastItem().remove();
            }
        }else{ alert("表を選択してから実行してください。"); }
    }
}
app.doScript(main, ScriptLanguage.JAVASCRIPT, [], UndoModes.ENTIRE_SCRIPT);